#!/usr/bin/perl

# Display all values and arrays of Perl or PHP ver 1.0

$filename = $ARGV[0];

print "\nDisplay all values and arrays on a Perl or a PHP script ver 1.0\n";
print "Copyright (C) TOMIKAWA Yusui\n\n";

if ($filename eq '') {
print "Usage: perl values.pl \[a Perl or a PHP script file name\]\n";
print "e.g. perl values.pl myscript.pl\n\n";
print "You can output results to a file by typing as follows:\n";
print "perl values.pl \[a Perl or PHP script file name\] > \[an output filename\]\n";
print "e.g. perl values.pl myscript.php > value_list.txt\n\n";
exit(0);
}

if (!open(IN, $filename)) {
print "OMG you specified a file can not open!\n";
exit(0);
} else {
$c = 0; $d = 0;
while ($line = <IN>) {
$remind = $line;

while ($remind =~ /(\$[a-zA-Z0-9_]+)/) {
$value = $1; $remind = $';
$exist = 0;
for ($i = 0; $i <= $c; $i++) {
if ($acc_value[$i] eq $value) { $exist = 1; last; }
}
if ($exist == 0) { $acc_value[$c] = $value; $c++; }
}

$remind = $line;
while ($remind =~ /(\$[a-zA-Z0-9_]+\[[^\]]+\])/) {
$array = $1; $remind = $';
$exist = 0;
for ($i = 0; $i <= $d; $i++) {
if ($acc_array[$i] eq $array) { $exist = 1; last; }
}
if ($exist == 0) { $acc_array[$d] = $array; $d++; }
}

}
close(IN);
}

print "The value list\n";
$cl = 0;
for ($i = 0; $i <= $c; $i++) {
if ($acc_value[$i] ne '') {
print $acc_value[$i]."\n";
$cl = 1;
}
}

if ($cl == 0) { print "nothing!\n"; }

print "\n";

print "The array list\n";
$cl = 0;
for ($i = 0; $i <= $d; $i++) {
if ($acc_array[$i] ne '') {
print $acc_array[$i]."\n";
$cl = 1;
}
}

if ($cl == 0) { print "nothing!\n"; }

print "\n";
